#! - perl -

@in = ('abc',
       'abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq',
       'a' x 1000000);

@digest = ('A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D',
	   '84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1',
	   '34AA973C D4C4DAA4 F61EEB2B DBAD2731 6534016F');

@read = ('', '', '');

for $_ (0 .. 2) {
    open OUT, "| ./sha1test >shatest.$$.out";
    print OUT $in[$_];
    close OUT;
    open IN, "<shatest.$$.out";
    $digest = <IN>; chomp $digest; $digest =~ s/\r$//; $digest =~ s/\s+$//;
    $read[$_] = $digest;
    $tf |= (1 << $_) unless ($digest eq $digest[$_]);
}

unlink "shatest.$$.out";

if ($tf) {
    die "The following SHA1 test(s) failed:\n",
	($tf & 1 ? "#1 - `$in[0]'\n $digest[0]\n $read[0]\n" : ""),
	($tf & 2 ? "#2 - `$in[1]'\n $digest[1]\n $read[1]\n" : ""),
	($tf & 4 ? "#3 - 1000000 a's\n $digest[2]\n $read[2]\n" : "");
}

exit 0;
